/*
 * Boot the thing...
 *
 * Loads the first 32 instruction words from the emulated external eprom,
 * marks a BDMA interrupt pending, and returns.  main() should then start
 * execution at pm(0x0000).
 *
 */

#include "sim.h"

int bootdsp(void)
{
  fprintf(stderr, "bootdsp: Booting DSP via BDMA...\n");
  /* do the transfer */
  setmmapreg(MMAPREG_BDMACTL, 0x0000); /* clean flags */
  setmmapreg(MMAPREG_BEAD, 0x0000); /* load from 0x0000 */
  setmmapreg(MMAPREG_BIAD, 0x0000); /* load into 0x0000 */
  /* DSP grabs the first 32 insturctions (3bytes per instruction) */
  setmmapreg(MMAPREG_BWCOUNT, 32); /* also starts the transfer */
  
  /* FIXME: flag the interrupt */
  //irq_unflag(8); /* lets do this...im not real sure how its suppose to work */
  fprintf(stderr, "bootdsp: External Bootstrap Complete\n");

  return 0;
}
