/*
 * decode.c
 *
 * This is really where all the fun happens...
 *
 */

#include "sim.h"

typedef unsigned int (*opdecode_f)(unsigned int);

opdecode_f decodetable[] = {
  NULL,
  op_pmdmr,
  op_dmwim,
  op_dmrwim,
  op_dmrw,
  op_pmrw,
  op_loadregim,
  op_loadnondataregim,
  op_alumove,
  op_alu,
  op_jump,
  op_dountil,
  op_shiftdmrw,
  op_shiftpmrw,
  op_shiftmove,
  op_shiftim,
  op_shift,
  op_datamove,
  op_modectl,
  op_jumpindirect,
  op_return,
  op_modify,
  op_trap,
  op_divq,
  op_divs,
  op_satmr,
  op_stackctl,
  op_jumpfi,
  op_modifyfl,
  op_iorw,
  op_nop,
  op_idle,
  op_idlen
};


/*
 * 
 * Return the new PC if we commited a jump, else return 0 and the sequencer
 * will autoincrement for us.
 *
 */
unsigned int decode()
{
  unsigned int opcode;
  int type = 0;

  opcode = curdsp.sequencer.curinstr;
  
  type = getoptype(opcode);

  if (type && (type <= 32))
    return (*(decodetable[type]))(opcode);
  
  fprintf(stderr, "decode: unknown instruction\n");
  return 0;
}
