/*
 *
 *
 */

#ifndef __IRQ_H__
#define __IRQ_H__

#define IRQCOUNT 12
#define IRQWAITLEN 4  /* number of cycles from IRQ to ISR call, 3 for 2181 */

#define IRQ_HIGH 0x01

struct irq_s {
  char name[25];
  unsigned int vector; /* vector address */
  int count; /* elapsed ticks of this interrupt */
  int precount; /* number of instructions counted prior to the vector being called (for pipeline simulation) */
  int state; /* IRQ_HIGH */
};

int irq_initsingle(struct irq_s *irq, const char *name, unsigned int vector);
void irq_dump(void);
int irq_flag(int irq);
int irq_unflag(int irq);
int irq_checkpending(void);
int irq_checkdone(void);
int irq_incprecount(void);
void irq_setimask(unsigned int new);
unsigned int irq_getimask(void);
void irq_seticntl(unsigned int new);
unsigned int irq_geticntl(void);
void irq_setifc(unsigned int new);
unsigned int irq_getifc(void);
int irq_checkimask(int irq);

#endif /* __IRQ_H__ */
