/*
 *
 *
 */

#include "sim.h"


int getoptype(unsigned int opcode)
{
  if (opcode & BIT23) /* 1 */
    {
      if (opcode & BIT22) /* 11 -- type 1 */
	return 11;
      else /* 10 */
	{
	  if (opcode & BIT21) /* 101 -- type 2 */
	    return 2;
	  else /* 100 -- type 3 */
	    return 3;
	}
    }
  else /* 0 */
    {
      if (opcode & BIT22) /* 01 */
	{
	  if (opcode & BIT21) /* 011 -- type 4 */
	    return 4;
	  else /* 010 */
	    {
	      if (opcode & BIT20) /* 0101  -- type 5 */
		return 5;
	      else /* 0100 -- type 6 */
		return 6;
	    }
	}
      else  /* 00 */
	{
	  if (opcode & BIT21) /* 001 */
	    {
	      if (opcode & BIT20) 
		return 7;
	      else
		{
		  if (opcode & BIT19) 
		    return 8; 
		  else 
		    return 9;
		}
	    }
	  else /* 000 */
	    {
	      if (opcode & BIT20) /* 0001 */
		{
		  if (opcode & BIT19) /* 00011 -- type 10 */
		    return 10;
		  else /* 00010 */
		    {
		      if (opcode & BIT18) /* 000101 -- type 11 */
			return 11;
		      else /* 000100 */
			{
			  if (opcode & BIT17) 
			    return 12; /* type 12 */
			  else
			    {
			      if (opcode & BIT16)
				return 13; /* type 13 */
			      else
				return 14; /* type 14 */
			    }
			}
		    }
		}
	      else /* 0000 */
		{
		  if (opcode & BIT19) /* 0000 1 */
		    {
		      if (opcode & BIT18) /* 0000 11 */
			{
			  if (opcode & BIT17) /* 0000 111 */
			    {
			      if (opcode & BIT16) /* 0000 1111 */
				{
				  if (opcode & BIT15) 
				    ;
				  else /* type 15 */
				    return 15;
				}
			      else /* 0000 1110 */
				{
				  if (opcode & BIT15) /* 0000 1110 1 */
				    ;
				  else /* type 16 */
				    return 16;
				}
			    }
			  else /* 0000 110 */
			    {
			      if (opcode & BIT16) /* 0000 1101 -- type 17 */
				return 17;
			      else /* 0000 1100 */
				return 18; /* type 18 */
			    }
			}
		      else /* 0000 10 */
			{
			  if ((opcode >> 4) == 0xa001) /* rti */
			    return 20; /* type 20 */
			  else if ((opcode >> 4) == 0xa000) /* rts */
			    return 20; /* type 20 */
			  else if ((opcode >> 4) == 0x09080)
			    return 21; /* type 21 */
			  else if ((opcode >> 8) == 0x0b00)
			    return 19;
			}
		    }
		  else /* 0000 0 */
		    {
		      if (opcode & BIT18) /* 0000 01 */
			{
			  if ((opcode >> 5) == 0x2000)
			    return 26; /* type 26 */
			  else if (opcode & BIT17) /* 0000 011 */
			    {
			      if (opcode & BIT16) /* 0000 0111 */
				return 23; /* type 23 */
			      else /* 0000 0110 */
				return 24; /* type 24 */
			    }
			  else if (opcode == 0x050000)
			    return 25; /* type 25 */
			}
		      else /* 000000 */
			{
			  if (opcode & BIT17) /* 0000 001 */
			    {
			      if (opcode & BIT16) /* 0000 0011 -- type 27 */
				return 27;
			      else /* 0000 0010 -- type 28 */
				return 28;
			    }
			  else /* 0000 000 */
			    {
			      if (opcode & BIT16) /* 0000 0001 -- type 29 */
				return 29;
			      else /* 0000 0000 */
				{
				  if (opcode == 0x000000)
				    return 30; /* type 30 */
				  else if ((opcode>>4) == 0x02800) 
				    {
				      if (opcode & 0xf)
					return 32; /* type 31 */
				      else
					return 31; /* type 31 */
				    }
				}
			    }
			}
		    }
		}
	    }
	}
    }
  return 0;
}
