/*
 * Tables used by pretty disassembler
 *
 *
 */

#ifndef __PRETTY_TABLES_H__
#define __PRETTY_TABLES_H__

/* [row][col][stringlen] */
static char regs[16][4][15] = {
  {"ax0", "i0", "i4", "astat"},
  {"ax1", "i1", "i5", "mstat"},
  {"mx0", "i2", "i6", "sstat"},
  {"mx1", "i3", "i7", "imask"},
  {"ay0", "m0", "m4", "icntl"},
  {"ay1", "m1", "m5", "cntr"},
  {"my0", "m2", "m6", "sb"},
  {"my1", "m3", "m7", "px"},
  {"si", "l0", "l4", "rx0"},
  {"se", "l1", "l5", "tx0"},
  {"ar", "l2", "l6", "rx1"},
  {"mr0", "l3", "l7", "rx1"},
  {"mr1", "", "", "ifc"},
  {"mr2", "", "", "owrcntr"},
  {"sr0", "pmovlay", "", ""},
  {"sr1", "", "", "toppcstack"}
};

static char axops[8][15] = {
  "ax0",
  "ax1",
  "ar",
  "mr0",
  "mr1",
  "mr2",
  "sr0",
  "sr1"
};

static char mxops[8][15] = {
  "mx0",
  "mx1",
  "ar",
  "mr0",
  "mr1",
  "mr2",
  "sr0",
  "sr1"
};

static char ayops[4][15] = {
  "ay0",
  "ay1",
  "af",
  "zero"
};

static char myops[4][15] = {
  "my0",
  "my1",
  "mf",
  "zero"
};

static char sfs[16][3][15] = {
  {"lshift", "(hi)", {0}},
  {"lshift", "(hi)", {1}},
  {"lshift", "(lo)", {0}},
  {"lshift", "(lo)", {1}},
  {"ashift", "(hi)", {0}},
  {"ashift", "(hi)", {1}},
  {"ashift", "(lo)", {0}},
  {"ashift", "(lo)", {1}},
  {"norm", "(hi)", {0}},
  {"norm", "(hi)", {1}},
  {"norm", "(lo)", {0}},
  {"norm", "(lo)", {1}},
  {"exp", "(hi)", {0}},
  {"exp", "(hix)", {0}},
  {"exp", "(lo)", {0}},
  {"dbe", "", {0}}
};

static char conds[16][15] = {
  "eq",
  "ne", 
  "gt", 
  "le",
  "lt",
  "ge",
  "av",
  "not av",
  "ac", 
  "not ac",
  "neg",
  "pos",
  "mv",
  "not mv",
  "not ce",
  "" /* always true */
};

static char loopconds[16][15] = {
  "ne",
  "eq",
  "le",
  "gt",
  "ge",
  "lt",
  "not av",
  "av",
  "not ac",
  "ac",
  "pos",
  "neg",
  "not mv",
  "mv",
  "ce",
  "forever" /* always true */
};

static char flagops[4][15] = {
  "nochange",
  "toggle",
  "reset",
  "set"
};

#endif /* __PRETTY_TABLES_H__ */
