/*
 * Miscellaneous register-related stuff.  This should really
 * be better categorized.
 *
 * FIXME: Split this up into more files.  Too much bloat.
 *
 */

#include "sim.h"

void setregrgp(unsigned int reg, unsigned int rgp, unsigned short val)
{
  short *regptr;
  if ((regptr = getregptr_rgp(reg,rgp))) /* we do most of them in here */
    *regptr = val;
  else if (setdagregrgp(reg, rgp, val)) /* some more here (the 14bitters) */
    ;
  else if (setnondataregrgp(reg, rgp, val)!=0xffffffff) /* and the rest here */
    ;
  else
    fprintf(stderr, "setregrgp: register set failed (%01x/%01x)\n", reg, rgp);
  return;
}

void regmove(unsigned int destreg, unsigned int destrgp, unsigned int srcreg, unsigned int srcrgp)
{
  short *destptr, *srcptr;
  short srcval;

  if (!(srcptr = getregptr_rgp(srcreg,srcrgp)))
    {
      if ((srcval = getnondataregrgp(srcreg, srcrgp)) == 0xffffffff)
	{
	  short14 *srcval14;
	  /* must be an ireg */
	  if (!(srcval14 = getdagregrgp_ptr(srcreg, srcrgp)))
	    {
	      if ((srcrgp==0x3)&&(srcreg==0xf)) /* toppcstack */
		srcval = pc_pop();
	      else
		{
		  fprintf(stderr, "regmove: unable to get source value!\n");
		  return;
		}
	    }
	  else
	    srcval = srcval14->n&0x3fff;
	}
      srcptr = &srcval;
    }

  if ((destptr = getregptr_rgp(destreg, destrgp)))
    *destptr = *srcptr;
  else if (setdagregrgp(destreg, destrgp, *srcptr & 0x3fff))
    setdagregrgp(destreg, destrgp+3, *srcptr & 0x3fff); /* update _B reg */
  else if (setnondataregrgp(destreg, destrgp, *srcptr))
      ;
  else if ( (destrgp==0x3) && (destreg==0xf) ) /* toppcstack */
    {
      short14 temp;
      temp.n = curdsp.sequencer.pc.n;
      curdsp.sequencer.pc.n = *srcptr;
      pc_push();
      curdsp.sequencer.pc.n = temp.n;
    }
  else
    fprintf(stderr, "regmove: register move failed (%01x/%01x to %01x/%01x)\n", srcreg, srcrgp, destreg, destrgp);
  
  return;
}

int setnondataregrgp(unsigned int reg, unsigned int rgp, unsigned short val)
{
  switch (rgp)
    {
    case 0x00:
      break;
    case 0x01:
      break;
    case 0x02:
      break;
    case 0x03:
      switch (reg)
	{
	case 0x00:
	  set_astat(val);
	  return 1;
	case 0x01:
	  set_mstat(val);
	  return 1;
	case 0x02: 
	  return 0; /* sstat is read only! */ 
	case 0x03:
	  irq_setimask(val);
	  return 1;
	case 0x04:
	  irq_seticntl(val);
	  return 1;
	case 0x05:
	  set_cntr(val);
	  return 1;
	case 0x0c:
	  irq_setifc(val);
	  return 1;
	case 0x0d: /* actually OWRCNTR, but same as overwriting CNTR */
	  set_cntr(val);
	  return 1;
	}
      break;
    }
  return 0;
}

/*
 * Setting and retrieving the wonderful 14bit DAG registers.
 *
 * We use a struct (_short14) that encapsulates a 14bit bitfield
 * so that we can do true 14bit arithmetic.  Now we could do 14bit
 * arithmetic using arithmetic, but I made the decision to use
 * bitfields and make C do it for us.  You love me don't you?
 *
 * In any case, short14->n = 0x3fff with get you a -1, just like
 * a real DAG would.  
 *
 */
int setdagregrgp(unsigned int reg, unsigned int rgp, unsigned short val)
{
  short14 val14;
  short14 *regptr=NULL;

  val14.n = val;
  if (!(regptr = getdagregrgp_ptr(reg, rgp)))
    return 0;
  regptr->n = val14.n;
  return 1;
}

short14 *getdagregrgp_ptr(unsigned int reg, unsigned int rgp)
{
  switch (rgp)
    {
    case 0x01:
      switch(reg)
	{
	case 0x00: return &curdsp.dag.dag1.i0;
	case 0x01: return &curdsp.dag.dag1.i1;
	case 0x02: return &curdsp.dag.dag1.i2;
	case 0x03: return &curdsp.dag.dag1.i3;
	case 0x04: return &curdsp.dag.dag1.m0;
	case 0x05: return &curdsp.dag.dag1.m1;
	case 0x06: return &curdsp.dag.dag1.m2;
	case 0x07: return &curdsp.dag.dag1.m3;
	case 0x08: return &curdsp.dag.dag1.l0;
	case 0x09: return &curdsp.dag.dag1.l1;
	case 0x0a: return &curdsp.dag.dag1.l2;
	case 0x0b: return &curdsp.dag.dag1.l3;
	default: return NULL;
	}
    case 0x02:
      switch(reg)
	{
	case 0x00: return &curdsp.dag.dag2.i4;
	case 0x01: return &curdsp.dag.dag2.i5;
	case 0x02: return &curdsp.dag.dag2.i6;
	case 0x03: return &curdsp.dag.dag2.i7;
	case 0x04: return &curdsp.dag.dag2.m4;
	case 0x05: return &curdsp.dag.dag2.m5;
	case 0x06: return &curdsp.dag.dag2.m6;
	case 0x07: return &curdsp.dag.dag2.m7;
	case 0x08: return &curdsp.dag.dag2.l4;
	case 0x09: return &curdsp.dag.dag2.l5;
	case 0x0a: return &curdsp.dag.dag2.l6;
	case 0x0b: return &curdsp.dag.dag2.l7;
	default: return NULL;
	}
    case 0x04: /* internal use only!!! */
      switch(reg)
	{
	case 0x00: return &curdsp.dag.dag1._b0;
	case 0x01: return &curdsp.dag.dag1._b1;
	case 0x02: return &curdsp.dag.dag1._b2;
	case 0x03: return &curdsp.dag.dag1._b3;
	default: return NULL;
	}
    case 0x05: /* internal use only!!! */
      switch(reg)
	{
	case 0x00: return &curdsp.dag.dag2._b4;
	case 0x01: return &curdsp.dag.dag2._b5;
	case 0x02: return &curdsp.dag.dag2._b6;
	case 0x03: return &curdsp.dag.dag2._b7;
	default: return NULL;
	}
    case 0x00:
    case 0x03:
    default:
      return NULL;
    }

  return NULL;
}

unsigned int getnondataregrgp(unsigned int reg, unsigned int rgp)
{
  switch (rgp)
    {
    case 0x00:
      break;
    case 0x01:
      break;
    case 0x02:
      break;
    case 0x03:
      switch (reg)
	{
	case 0x00: return get_astat();
	case 0x01: return get_mstat();
	case 0x02: return get_sstat();    
	case 0x03: return irq_getimask();
	case 0x04: return irq_geticntl();
	case 0x05: return get_cntr();
      	case 0x0c: return irq_getifc();
	}
      break;
    }
  return 0xffffffff;
}

/*
 * Get a pointer to the register encoded in reg and rgp.
 *
 * FIXME: fill in the rest of these
 *
 */
unsigned short *getregptr_rgp(unsigned int reg, unsigned int rgp)
{
  switch(rgp)
    {
    case 0x00:
      switch (reg)
	{
	case 0x0000: return &curdsp.alu.cur->ax0;
	case 0x0001: return &curdsp.alu.cur->ax1;
	case 0x0002: return &curdsp.mac.cur->mx0;
	case 0x0003: return &curdsp.mac.cur->mx1;
	case 0x0004: return &curdsp.alu.cur->ay0;
	case 0x0005: return &curdsp.alu.cur->ay1;
	case 0x0006: return &curdsp.mac.cur->my0;
	case 0x0007: return &curdsp.mac.cur->my1;
	case 0x0008: return &curdsp.shifter.cur->si;
	case 0x0009: return (unsigned short *)&curdsp.shifter.cur->se;
	case 0x000a: return &curdsp.alu.cur->ar;
	case 0x000b: return &curdsp.mac.cur->mr.mrx.mr0;
	case 0x000c: return &curdsp.mac.cur->mr.mrx.mr1;
	case 0x000d: return (unsigned short *)&curdsp.mac.cur->mr.mrx.mr2;
	case 0x000e: return &curdsp.shifter.cur->sr.srx.sr0;
	case 0x000f: return &curdsp.shifter.cur->sr.srx.sr1;
	}
      break;
    case 0x01:
      switch (reg)
	{
#if 0
	case 0x00: return &curdsp.dag.dag1.i0;
	case 0x01: return &curdsp.dag.dag1.i1;
	case 0x02: return &curdsp.dag.dag1.i2;
	case 0x03: return &curdsp.dag.dag1.i3;
	case 0x04: return &curdsp.dag.dag1.m0;
	case 0x05: return &curdsp.dag.dag1.m1;
	case 0x06: return &curdsp.dag.dag1.m2;
	case 0x07: return &curdsp.dag.dag1.m3;
	case 0x08: return &curdsp.dag.dag1.l0;
	case 0x09: return &curdsp.dag.dag1.l1;
	case 0x0a: return &curdsp.dag.dag1.l2;
	case 0x0b: return &curdsp.dag.dag1.l3;
#endif
	}
      break;
    case 0x02:
      switch (reg)
	{
#if 0
	case 0x00: return &curdsp.dag.dag2.i4;
	case 0x01: return &curdsp.dag.dag2.i5;
	case 0x02: return &curdsp.dag.dag2.i6;
	case 0x03: return &curdsp.dag.dag2.i7;
	case 0x04: return &curdsp.dag.dag2.m4;
	case 0x05: return &curdsp.dag.dag2.m5;
	case 0x06: return &curdsp.dag.dag2.m6;
	case 0x07: return &curdsp.dag.dag2.m7;
	case 0x08: return &curdsp.dag.dag2.l4;
	case 0x09: return &curdsp.dag.dag2.l5;
	case 0x0a: return &curdsp.dag.dag2.l6;
	case 0x0b: return &curdsp.dag.dag2.l7; 
#endif
	}
      break;
    case 0x03:
      switch (reg)
	{
	}
      break;
    }
  return NULL;
}

void dump_alu(void)
{
  fprintf(stderr, " --- ALU Registers --- \n");
  fprintf(stderr, "  reg\t%4s\t\t%4s\t\t%4s\n", "cur", "pri", "sec");
  fprintf(stderr, "ax0 =\t%04x\t\t%04x\t\t%04x\n", curdsp.alu.cur->ax0, curdsp.alu.pri.ax0, curdsp.alu.sec.ax0);
  fprintf(stderr, "ax1 =\t%04x\t\t%04x\t\t%04x\n", curdsp.alu.cur->ax1, curdsp.alu.pri.ax1, curdsp.alu.sec.ax1);
  fprintf(stderr, "ay0 =\t%04x\t\t%04x\t\t%04x\n", curdsp.alu.cur->ay0, curdsp.alu.pri.ay0, curdsp.alu.sec.ay0); 
  fprintf(stderr, "ay1 =\t%04x\t\t%04x\t\t%04x\n", curdsp.alu.cur->ay1, curdsp.alu.pri.ay1, curdsp.alu.sec.ay1);
  fprintf(stderr, "ar  =\t%04x\t\t%04x\t\t%04x\n", curdsp.alu.cur->ar, curdsp.alu.pri.ar, curdsp.alu.sec.ar);
  fprintf(stderr, "af  =\t%04x\t\t%04x\t\t%04x\n", curdsp.alu.cur->af, curdsp.alu.pri.af, curdsp.alu.sec.af);
  fprintf(stderr, " --------------------- \n");
  return;
}

void dump_mac(void)
{
  fprintf(stderr, " --- MAC Registers --- \n");
  fprintf(stderr, "mx0 =\t%04x\t\t%04x\t\t%04x\n", curdsp.mac.cur->mx0, curdsp.mac.pri.mx0, curdsp.mac.sec.mx0);
  fprintf(stderr, "mx1 =\t%04x\t\t%04x\t\t%04x\n", curdsp.mac.cur->mx1, curdsp.mac.pri.mx1, curdsp.mac.sec.mx1);
  fprintf(stderr, "my0 =\t%04x\t\t%04x\t\t%04x\n", curdsp.mac.cur->my0, curdsp.mac.pri.my0, curdsp.mac.sec.my0);
  fprintf(stderr, "my1 =\t%04x\t\t%04x\t\t%04x\n", curdsp.mac.cur->my1, curdsp.mac.pri.my1, curdsp.mac.sec.my1);
#if 0
  fprintf(stderr, "mr  =\t%010llx\t%010llx\t%010llx\n", 
	  (unsigned long long)curdsp.mac.cur->mr.mr,
	  (unsigned long long)curdsp.mac.pri.mr.mr,
	  (unsigned long long)curdsp.mac.sec.mr.mr);
#endif
  fprintf(stderr, "mr0 =\t%04x\t\t%04x\t\t%04x\n", curdsp.mac.cur->mr.mrx.mr0, curdsp.mac.pri.mr.mrx.mr0, curdsp.mac.sec.mr.mrx.mr0);
  fprintf(stderr, "mr1 =\t%04x\t\t%04x\t\t%04x\n", curdsp.mac.cur->mr.mrx.mr1, curdsp.mac.pri.mr.mrx.mr1, curdsp.mac.sec.mr.mrx.mr1);
  fprintf(stderr, "mr2 =\t%4x\t\t%4x\t\t%4x\n", curdsp.mac.cur->mr.mrx.mr2, curdsp.mac.pri.mr.mrx.mr2, curdsp.mac.sec.mr.mrx.mr2);

 
#if 0
	  (unsigned long long)((unsigned long long)curdsp.mac.cur->mr.mrx.mr0)+
	  ((unsigned long long)curdsp.mac.cur->mr.mrx.mr1<<16)+
	  ((unsigned long long)curdsp.mac.cur->mr.mrx.mr2<<32), 
	  ((unsigned long long)curdsp.mac.pri.mr.mrx.mr0)+
	  ((unsigned long long)curdsp.mac.pri.mr.mrx.mr1<<16)+
	  ((unsigned long long)curdsp.mac.pri.mr.mrx.mr2<<32), 
	  ((unsigned long long)curdsp.mac.sec.mr.mrx.mr0)+
	  ((unsigned long long)curdsp.mac.sec.mr.mrx.mr1<<16)+
	  ((unsigned long long)curdsp.mac.sec.mr.mrx.mr2<<32));
#endif
  fprintf(stderr, "mf  =\t%04x\t\t%04x\t\t%04x\n", curdsp.mac.cur->mf, curdsp.mac.pri.mf, curdsp.mac.sec.mf);
  fprintf(stderr, " --------------------- \n");
  return;
}

/*
 * The main thing to remember here is that when accessing DAG registers
 * as shorts, you must first take care to use the struct member (n) and not
 * the actual struct (counterintuitive, i know) and to make sure that
 * you AND off the upper two bits (ie, & 0x3fff).
 *
 */
void dump_dags(void)
{
  fprintf(stderr, " -- DAG Registers ---------------------------------------------------------\n");
  fprintf(stderr, "  \t%4x\t%4x\t%4x\t%4x\t|\t%4x\t%4x\t%4x\t%4x\n",
	  0, 1, 2, 3, 4, 5, 6, 7);
  fprintf(stderr, " i:\t%04x\t%04x\t%04x\t%04x\t|\t%04x\t%04x\t%04x\t%04x\n", 
	  curdsp.dag.dag1.i0.n & 0x3fff,
	  curdsp.dag.dag1.i1.n & 0x3fff,
	  curdsp.dag.dag1.i2.n & 0x3fff,
	  curdsp.dag.dag1.i3.n & 0x3fff,
	  curdsp.dag.dag2.i4.n & 0x3fff,
	  curdsp.dag.dag2.i5.n & 0x3fff,
	  curdsp.dag.dag2.i6.n & 0x3fff,
	  curdsp.dag.dag2.i7.n & 0x3fff);
  fprintf(stderr, " l:\t%04x\t%04x\t%04x\t%04x\t|\t%04x\t%04x\t%04x\t%04x\n", 
	  curdsp.dag.dag1.l0.n & 0x3fff,
	  curdsp.dag.dag1.l1.n & 0x3fff,
	  curdsp.dag.dag1.l2.n & 0x3fff,
	  curdsp.dag.dag1.l3.n & 0x3fff,
	  curdsp.dag.dag2.l4.n & 0x3fff,
	  curdsp.dag.dag2.l5.n & 0x3fff,
	  curdsp.dag.dag2.l6.n & 0x3fff,
	  curdsp.dag.dag2.l7.n & 0x3fff);
  fprintf(stderr, " m:\t%04x\t%04x\t%04x\t%04x\t|\t%04x\t%04x\t%04x\t%04x\n", 
	  curdsp.dag.dag1.m0.n & 0x3fff,
	  curdsp.dag.dag1.m1.n & 0x3fff,
	  curdsp.dag.dag1.m2.n & 0x3fff,
	  curdsp.dag.dag1.m3.n & 0x3fff,
	  curdsp.dag.dag2.m4.n & 0x3fff,
	  curdsp.dag.dag2.m5.n & 0x3fff,
	  curdsp.dag.dag2.m6.n & 0x3fff,
	  curdsp.dag.dag2.m7.n & 0x3fff);
  fprintf(stderr, "_b:\t%04x\t%04x\t%04x\t%04x\t|\t%04x\t%04x\t%04x\t%04x\n", 
	  curdsp.dag.dag1._b0.n & 0x3fff,
	  curdsp.dag.dag1._b1.n & 0x3fff,
	  curdsp.dag.dag1._b2.n & 0x3fff,
	  curdsp.dag.dag1._b3.n & 0x3fff,
	  curdsp.dag.dag2._b4.n & 0x3fff,
	  curdsp.dag.dag2._b5.n & 0x3fff,
	  curdsp.dag.dag2._b6.n & 0x3fff,
	  curdsp.dag.dag2._b7.n & 0x3fff);
  fprintf(stderr, " --------------------------------------------------------------------------\n");
  return;
}

void dump_shifter(void)
{
  fprintf(stderr, " --- Shifter Registers --- \n");
  fprintf(stderr, "  reg\t%4s\t\t%4s\t\t%4s\n", "cur", "pri", "sec");
  fprintf(stderr, "sr  =\t%08x\t%08x\t%08x\n", curdsp.shifter.cur->sr.sr, curdsp.shifter.pri.sr.sr, curdsp.shifter.sec.sr.sr);
  fprintf(stderr, "sr0 =\t%04x\t\t%04x\t\t%04x\n", curdsp.shifter.cur->sr.srx.sr0, curdsp.shifter.pri.sr.srx.sr0, curdsp.shifter.sec.sr.srx.sr0);
 fprintf(stderr, "sr1 =\t%04x\t\t%04x\t\t%04x\n", curdsp.shifter.cur->sr.srx.sr1, curdsp.shifter.pri.sr.srx.sr1, curdsp.shifter.sec.sr.srx.sr1);
 fprintf(stderr, "si  =\t%04x\t\t%04x\t\t%04x\n", curdsp.shifter.cur->si, curdsp.shifter.pri.si, curdsp.shifter.sec.si);
 fprintf(stderr, "se  =\t%04x\t\t%04x\t\t%04x\n", curdsp.shifter.cur->se, curdsp.shifter.pri.se, curdsp.shifter.sec.se);

  fprintf(stderr, " ------------------------- \n");
  return;
}

/*
 * setmmapreg(regaddr, val)
 *
 * Sets memory-mapped register at regaddr with byte value val.
 *
 * Also calls things that depend on these values changing,
 * such as the BDMA start when MMAPREG_BWCOUNT is set.
 *
 */
int setmmapreg(unsigned int regaddr, unsigned short val)
{
  if ((regaddr < 0x3fe0) || (regaddr > 0x3fff))
    {
      fprintf(stderr, "setmmapreg: regaddr out of range\n");
      return -1;
    }

  curdsp.dm[regaddr*2] = (val >> 8) &0xff;
  curdsp.dm[(regaddr*2)+1] = val &0xff;
  
  switch (regaddr)
    {
    case MMAPREG_BWCOUNT:
      bdma_dotransfer();
      break;
    case MMAPREG_SYSCTL:
      if (val&0x7)
	fprintf(stderr, "setmmapreg: unsupported: PWAIT = %x\n", val&0x7);
      if (val&0x400)
	fprintf(stderr, "setmmapreg: unsupported: SPORT1CFG = %x\n", val&0x400?1:0);
      break;
    default:
      break;
    }
  return 0;
}

/*
 * getmmapreg(regaddr) = val
 *
 * Returns the value of the memory-mapped register at regaddr.
 *
 * Also facilitates the watching of the reads, just like setmmapreg().
 *
 */
unsigned short getmmapreg(unsigned int regaddr)
{
  if ((regaddr < 0x3fe0) || (regaddr > 0x3fff))
    {
      fprintf(stderr, "getmmapreg: regaddr out of range\n");
      return -1;
    }
  
  switch(regaddr)
    {
    default:
      break;
    }
  
  return ((curdsp.dm[regaddr*2]<<8)+curdsp.dm[(regaddr*2)+1]);
}

void reg_flipset(int val)
{
  if (val) /* go to secondary registers */
    {
      curdsp.alu.cur = &curdsp.alu.sec;
      curdsp.mac.cur = &curdsp.mac.sec;
      curdsp.shifter.cur = &curdsp.shifter.sec;
    }
  else /* go to primary registers */
    {
      curdsp.alu.cur = &curdsp.alu.pri;
      curdsp.mac.cur = &curdsp.mac.pri;
      curdsp.shifter.cur = &curdsp.shifter.pri;
    }
}


void set_mstatbit(unsigned int bit) {set_mstat(get_mstat()|bit);}
void set_mstatclearbit(unsigned int bit)
{
  if (get_mstat()&bit)
    set_mstat(get_mstat() ^ bit);
  return;
}
void set_mstat(unsigned int new) 
{
  curdsp.sequencer.mstat = new; 
  if (new & 0x01)
    reg_flipset(1);
  else
    reg_flipset(0);

  return; 
}

unsigned int get_mstat(void) {return curdsp.sequencer.mstat; }
void set_sstat(unsigned int new) {curdsp.sequencer.sstat = new; return; }
unsigned int get_sstat(void) {return curdsp.sequencer.sstat; }
void set_astat(unsigned int new) {curdsp.sequencer.astat = new; return; }
unsigned int get_astat(void) {return curdsp.sequencer.astat; }
unsigned int get_astatbit(unsigned int bit) {return curdsp.sequencer.astat & bit;}
void set_astatbit(unsigned int new) { curdsp.sequencer.astat |= new; return;}
void set_astatclearbit(unsigned int new)
{
  if (curdsp.sequencer.astat & new)
    curdsp.sequencer.astat ^= new;
  return;
}

/*
 * Test Conditions (for everything but Loops)
 */
int testcond(unsigned int cond)
{
  switch (cond)
    {
    case 0x0: /* EQ */
      return get_astatbit(ASTAT_AZ);
    case 0x1: /* NE */
      return !get_astatbit(ASTAT_AZ);
    case 0x2: /* GT */
      return !((get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV)) | 
	     get_astatbit(ASTAT_AZ));
    case 0x3: /* LE */
      return ((get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV)) | 
	      get_astatbit(ASTAT_AZ));
    case 0x4: /* LT */
      return get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV);
    case 0x5: /* GE */
      return !(get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV));
    case 0x6: /* AV */
      return get_astatbit(ASTAT_AV);
    case 0x7: /* NOT AV */
      return !get_astatbit(ASTAT_AV);
    case 0x8: /* AC */
      return get_astatbit(ASTAT_AC);
    case 0x9: /* NOT AC */
      return !get_astatbit(ASTAT_AC);
    case 0xa: /* NEG */
      return get_astatbit(ASTAT_AS);
    case 0xb: /* POS */
      return !get_astatbit(ASTAT_AS);
    case 0xc: /* MV */
      return get_astatbit(ASTAT_MV);
    case 0xd: /* NOT MV */
      return !get_astatbit(ASTAT_MV);
    case 0xe: /* NOT CE -- FIXME: counter>1 */
      return (curdsp.sequencer.cntr>1);
    case 0xf: /* TRUE */
      return 1;
    }
  return 0;
}

/*
 * Termination Conditions (for loops)
 */
int testtermcond(unsigned int cond)
{
  switch (cond)
    {
    case 0x0: /* NE */
      return !get_astatbit(ASTAT_AZ);
    case 0x1: /* EQ */
      return get_astatbit(ASTAT_AZ);
    case 0x3: /* GT */
      return !((get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV)) | 
	     get_astatbit(ASTAT_AZ));
    case 0x2: /* LE */
      return ((get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV)) | 
	      get_astatbit(ASTAT_AZ));
    case 0x5: /* LT */
      return get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV);
    case 0x4: /* GE */
      return !(get_astatbit(ASTAT_AN)^get_astatbit(ASTAT_AV));
    case 0x7: /* AV */
      return get_astatbit(ASTAT_AV);
    case 0x6: /* NOT AV */
      return !get_astatbit(ASTAT_AV);
    case 0x9: /* AC */
      return get_astatbit(ASTAT_AC);
    case 0x8: /* NOT AC */
      return !get_astatbit(ASTAT_AC);
    case 0xb: /* NEG */
      return get_astatbit(ASTAT_AS);
    case 0xa: /* POS */
      return !get_astatbit(ASTAT_AS);
    case 0xd: /* MV */
      return get_astatbit(ASTAT_MV);
    case 0xc: /* NOT MV */
      return !get_astatbit(ASTAT_MV);
    case 0xe: /* NOT CE */
      return (curdsp.sequencer.cntr>1);
    case 0xf: /* TRUE */
      return 1;
    }
  return 0;
}
